Bug 841152 - readline breaks if we put a stream filter over sys.stdout
readline breaks if we put a stream filter over sys.stdout
Status: CLOSED EOL
Product: Fedora
Classification: Fedora
Component: python (Show other bugs)
19
Unspecified Unspecified
unspecified Severity unspecified
: ---
: ---
Assigned To: Bohuslav "Slavek" Kabrda
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2012-07-18 05:44 EDT by Ales Kozumplik
Modified: 2015-02-17 09:21 EST (History)
6 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2015-02-17 09:21:26 EST
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
simple program demonstrating the issue (640 bytes, text/plain)
2012-07-18 05:44 EDT, Ales Kozumplik
no flags Details

  None (edit)
Description Ales Kozumplik 2012-07-18 05:44:54 EDT
Created attachment 598838 [details]
simple program demonstrating the issue

In Yum/DNF a custom object is overriding sys.stdout. It's only job is to encode Unicode strings sent to output (e.g. via 'print') so yum doesn't die on UnicodeError when its output is redirected to a file.

I was wondering why cursor keys in pdb don't traverse the readline history as expected, it turns out assigning custom objects to sys.stdout silently disables readline. Attached is a trivial program demonstrating this.
Comment 1 Bohuslav "Slavek" Kabrda 2012-07-19 04:13:30 EDT
I would consider moving to Python 3 from Python 2. This problem doesn't appear in Python 3 (note that the function is not called "raw_input", but "input"). Also the unicode handling is much better in Python 3.
In the meantime, I will try to investigate this issue and come out with a solution for Python 2.
Comment 2 Bohuslav "Slavek" Kabrda 2012-07-20 04:54:11 EDT
It seems that the core of the problem is in function "builtin_raw_input" in file Python/bltinmodule.c - there are 2 checks that try to find out whether stdin and stdout are tty.
This in turn triggers some checks, whether type of stdout is types.FileType etc. So the only way I could think of is make UnicodeStream subclass of types.FileType. I however still can't find a way to properly redefine the methods/attributes in UnicodeStream and I keep getting
"ValueError: I/O operation on closed file"
no matter how I override the closed() or any other method/attribute. So no luck in this end.

Looking at Python 3 way, the logic of finding out whether stdout is a tty is completely rewritten [1] and I think that Python 2 version would need significant adjustments to work this way. Maybe Dave, who understands Python's C implementation much better, might be able to answer backporting this behaviour would be sane.


[1] http://hg.python.org/cpython/file/abc26b51fbfc/Python/bltinmodule.c#l1642
Comment 3 Fedora End Of Life 2013-04-03 10:38:18 EDT
This bug appears to have been reported against 'rawhide' during the Fedora 19 development cycle.
Changing version to '19'.

(As we did not run this process for some time, it could affect also pre-Fedora 19 development
cycle bugs. We are very sorry. It will help us with cleanup during Fedora 19 End Of Life. Thank you.)

More information and reason for this action is here:
https://fedoraproject.org/wiki/BugZappers/HouseKeeping/Fedora19
Comment 4 Fedora Admin XMLRPC Client 2013-05-10 00:59:30 EDT
This package has changed ownership in the Fedora Package Database.  Reassigning to the new owner of this component.
Comment 5 Fedora Admin XMLRPC Client 2013-05-10 01:00:40 EDT
This package has changed ownership in the Fedora Package Database.  Reassigning to the new owner of this component.
Comment 7 Fedora End Of Life 2015-01-09 12:15:52 EST
This message is a notice that Fedora 19 is now at end of life. Fedora 
has stopped maintaining and issuing updates for Fedora 19. It is 
Fedora's policy to close all bug reports from releases that are no 
longer maintained. Approximately 4 (four) weeks from now this bug will
be closed as EOL if it remains open with a Fedora 'version' of '19'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not 
able to fix it before Fedora 19 is end of life. If you would still like 
to see this bug fixed and are able to reproduce it against a later version 
of Fedora, you are encouraged  change the 'version' to a later Fedora 
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.
Comment 8 Fedora End Of Life 2015-02-17 09:21:26 EST
Fedora 19 changed to end-of-life (EOL) status on 2015-01-06. Fedora 19 is
no longer maintained, which means that it will not receive any further
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of
Fedora please feel free to reopen this bug against that version. If you
are unable to reopen this bug, please file a new report against the
current release. If you experience problems, please add a comment to this
bug.

Thank you for reporting this bug and we are sorry it could not be fixed.

Note You need to log in before you can comment on or make changes to this bug.